import pytest
import aiohttp
from aioresponses import aioresponses, compat as aioresponses_compat
import asynctest


pytest_plugins = "aiohttp.pytest_plugin"


@pytest.fixture
def responses():
    with aioresponses() as m:
        yield m


@pytest.fixture
def get_requests(responses):
    def get_calls(method, url):
        url = aioresponses_compat.normalize_url(url)
        return responses.requests[(method.upper(), url)]

    return get_calls


@pytest.fixture
async def session(loop):
    async with aiohttp.ClientSession() as session:
        yield session


@pytest.fixture
async def coroutine_mock():
    return asynctest.CoroutineMock
